<%#-- copyright
Nepenthes is a free and open project management software.
Copyright (C) 2024 The Nirvati developers

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

Nepenthes is a fork of OpenProject. The copyright follows:

Copyright (C) 2012-2024 the OpenProject GmbH

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
Copyright (C) 2006-2013 Jean-Philippe Lang
Copyright (C) 2010-2013 the ChiliProject Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

See COPYRIGHT and LICENSE files for more details.

++#%>
<%= toolbar title: @page.title %>
<% html_title t('activerecord.models.wiki'), t(:label_history) %>
<% breadcrumb_paths(*(@page.ancestors.reverse.collect { |parent| link_to h(parent.breadcrumb_title), {id: parent, project_id: parent.project}} + [h(@page.breadcrumb_title)] )) %>
<h3><%= t(:label_history) %></h3>
<%= form_tag({action: "diff"}, method: :get) do %>
  <div class="generic-table--container"
       data-application-target="dynamic"
       data-controller="journal-history">
    <div class="generic-table--results-container">
      <table class="generic-table wiki-page-versions">
        <colgroup>
          <col opHighlightCol>
          <col>
          <col>
          <col opHighlightCol>
          <col opHighlightCol>
          <col opHighlightCol>
          <col>
        </colgroup>
        <caption class="hidden-for-sighted">
          <span>
            <%= t(:text_table_difference_description, entries: t(:label_wiki_page) + ' ' + t(:label_version_plural)) %>
          </span>
        </caption>
        <thead>
          <tr>
            <th>
              <div class="generic-table--sort-header-outer">
                <div class="generic-table--sort-header">
                  <span aria-describedby="wiki-id--description">
                    #
                  </span>
                  <label id="wiki-id--description" class="hidden-for-sighted">
                    <%= t(:label_wiki_page_id) %>
                  </label>
                </div>
              </div>
            </th>
            </th>
            <th>
              <div class="generic-table--empty-header">
                <div class="generic-table--header">
                  <span>
                    <%= t(:description_compare_from) + ' ' + t(:label_version) %>
                  </span>
                </div>
              </div>
            </th>
            <th>
              <div class="generic-table--empty-header">
                <div class="generic-table--header">
                  <span>
                    <%= t(:description_compare_to) + ' ' + t(:label_version) %>
                  </span>
                </div>
              </div>
            </th>
            <th>
              <div class="generic-table--sort-header-outer">
                <div class="generic-table--sort-header">
                  <span>
                    <%= Journal.human_attribute_name(:updated_at) %>
                  </span>
                </div>
              </div>
            </th>
            <th>
              <div class="generic-table--sort-header-outer">
                <div class="generic-table--sort-header">
                  <span>
                    <%= Journal.human_attribute_name(:author) %>
                  </span>
                </div>
              </div>
            </th>
            <th>
              <div class="generic-table--sort-header-outer">
                <div class="generic-table--sort-header">
                  <span>
                    <%= Journal.human_attribute_name(:comments) %>
                  </span>
                </div>
              </div>
            </th>
            <th><div class="generic-table--empty-header"></div></th>
          </tr>
        </thead>
        <tbody>
          <% show_diff = @versions.size > 1 %>
          <% line_num = 1 %>
          <% @versions.each do |ver| %>
            <tr class="wiki-page-version">
              <td class="id"><%= link_to h(ver.version), action: 'show', id: @page, project_id: @page.project, version: ver.version %></td>
              <td class="checkbox">
                <% if show_diff && (line_num < @versions.size)  %>
                  <label for="<%="cb-#{line_num}"%>" class="hidden-for-sighted"><%= t(:description_compare_from) + ' ' + t(:label_version) + " " + h(ver.version.to_s) %></label>
                  <%= radio_button_tag('version_from',
                                       ver.version,
                                       (line_num==1),
                                       class: 'history-cb-from',
                                       id: "cb-#{line_num}",
                                       data: {
                                         'journal-history-target': 'fromVersion',
                                         action: 'journal-history#selectToVersion'
                                       }) %>
                <% end %>
              </td>
              <td class="checkbox">
                <% if show_diff && (line_num > 1) %>
                  <label for="<%="cbto-#{line_num}"%>" class="hidden-for-sighted"><%= t(:description_compare_to) + ' ' + t(:label_version) + " " + h(ver.version.to_s) %></label>
                  <%= radio_button_tag('version_to',
                                       ver.version,
                                       (line_num==2),
                                       id: "cbto-#{line_num}",
                                       data: {
                                         'journal-history-target': 'toVersion',
                                         action: 'journal-history#selectFromVersion'
                                       }) %>
                <% end %>
              </td>
              <td class="updated_at"><%= format_time(ver.created_at) %></td>
              <td class="author"><%= link_to_user ver.user %></td>
              <td class="comments"><%=h ver.notes %></td>
              <td class="buttons"><%= link_to t(:button_annotate), action: 'annotate', id: @page, version: ver.version %></td>
            </tr>
            <% line_num += 1 %>
          <% end %>
        </tbody>
      </table>

    </div>
  </div>
  <div class="generic-table--action-buttons">
    <%= submit_tag t(:label_view_diff), class: 'button -primary -small' if show_diff %>
  </div>
  <%= pagination_links_full @versions %>
<% end %>
